//+------------------------------------------------------------------+
//|                                                   MainWindow.mqh |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#include "Program.mqh"
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
bool CProgram::CreateWindow(const string caption_text)
  {
//---      
   CWndContainer::AddWindow(m_window);
//--- 
   int x_size=380;
   int y_size=600;
//--- 
   int x=1;
   int y=1;
//--- 
   m_window.XSize(x_size);
   m_window.YSize(y_size);
   m_window.Movable(true);
   m_window.UseRollButton();
   m_window.AutoXResizeMode(false);
   m_window.RollUpSubwindowMode(true,true);
//---  
   if(!m_window.CreateWindow(m_chart_id,m_subwin,caption_text,x,y))
      return(false);
//---
   return(true);
  }

//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
bool CProgram::CreateTabs(const int x_gap,const int y_gap)
  {
#define TABS1_TOTAL 6
//---    
   m_tabs.WindowPointer(m_window);
//--- 
   int x=m_window.X()+x_gap;
   int y=m_window.Y()+y_gap;
//---       
   string tabs_text[TABS1_TOTAL];
   for(int i=0; i<TABS1_TOTAL; i++)
     tabs_text[i]="Tab "+string(i+1);     
//---
   int tabs_width[TABS1_TOTAL];
   ArrayInitialize(tabs_width,55);
//---    
   m_tabs.YSize(243);
   m_tabs.TabYSize(20);
   m_tabs.PositionMode(TABS_TOP);
   m_tabs.AutoXResizeMode(true);
   m_tabs.AutoXResizeRightOffset(0);
   m_tabs.TabBorderColor(clrLightSteelBlue);
   m_tabs.SelectedTab((m_tabs.SelectedTab()==WRONG_VALUE) ? 0 : m_tabs.SelectedTab());
//---     
   for(int i=0; i<TABS1_TOTAL-3; i++)
      m_tabs.AddTab(tabs_text[i],tabs_width[i]);
      
      m_tabs.AddTab(tabs_text[3],40);
      m_tabs.AddTab(tabs_text[4],80);
      m_tabs.AddTab(tabs_text[5],80);
      
//---   
   if(!m_tabs.CreateTabs(m_chart_id,m_subwin,x,y))
      return(false);
//---       
   CWndContainer::AddToElementsArray(0,m_tabs);
   return(true);
  }

//+------------------------------------------------------------------+
//|   - 1                                    |
//+------------------------------------------------------------------+
bool CProgram::CreateRadioButtons1(const int x_gap,const int y_gap)
  {
//---    
   m_radio_buttons1.WindowPointer(m_window);
//---   1- 
   m_tabs.AddToElementsArray(0,m_radio_buttons1);
//--- 
   int x =m_window.X()+x_gap;
   int y =m_window.Y()+y_gap;
//--- 
   int    buttons_x_offset[] ={0,90,180};
   int    buttons_y_offset[] ={0,0,0};
   string buttons_text[]     ={"rb1","rb2","rb3"};
   int    buttons_width[]    ={92,92,92};
//---
   m_radio_buttons1.AreaColor(clrWhite);
//---     
   for(int i=0; i<3; i++)
      m_radio_buttons1.AddButton(buttons_x_offset[i],buttons_y_offset[i],buttons_text[i],buttons_width[i]);
//---   
   if(!m_radio_buttons1.CreateRadioButtons(m_chart_id,m_subwin,x,y))
      return(false);
//---     
   m_radio_buttons1.SelectionRadioButton(0);
//---      
   CWndContainer::AddToElementsArray(0,m_radio_buttons1);
   
    m_table.UpdateTable();
   return(true);
  }

//+------------------------------------------------------------------+
//|       Symbol                                             |
//+------------------------------------------------------------------+
bool CProgram::CreateTable(const int x_gap,const int y_gap)
  {
#define COLUMNS2_TOTAL (2)
#define ROWS2_TOTAL    (35)
//---    
   m_table.WindowPointer(m_window);
//---   1- 
   m_tabs.AddToElementsArray(0,m_table);
//--- 
   int x=m_window.X()+x_gap;
   int y=m_window.Y()+y_gap;
//---     
   int visible_columns_total =2;
   int visible_rows_total    =12;
//---    
   m_table.RowYSize(18);
   m_table.FixFirstRow(true);
   m_table.FixFirstColumn(true);
   m_table.LightsHover(true);
   m_table.SelectableRow(true);
   m_table.TextAlign(ALIGN_CENTER);
   m_table.HeadersColor(C'255,244,213');
   m_table.HeadersTextColor(clrBlack);
   m_table.CellColorHover(C'255,244,213');
   m_table.AutoXResizeMode(true);
   m_table.AutoXResizeRightOffset(1);
   m_table.TableSize(COLUMNS2_TOTAL,ROWS2_TOTAL);
   m_table.VisibleTableSize(visible_columns_total,visible_rows_total);
//---   
   if(!m_table.CreateTable(m_chart_id,m_subwin,x,y))
      return(false);
//---  :
   
//---   
      m_table.SetValue(0,0,"NAME");    m_table.TextAlign(0,0,ALIGN_CENTER);
      m_table.SetValue(1,0,"VALUE");   m_table.TextAlign(1,0,ALIGN_CENTER);
      
      ModifyTable(0);
           
//---     (    )
   for(int c=0; c<COLUMNS2_TOTAL; c++)
     {
      for(int r=1; r<ROWS2_TOTAL; r++)
        {
         m_table.TextAlign(c,r,(c%2==0)? ALIGN_RIGHT : ALIGN_CENTER);
         m_table.TextColor(c,r,(c%2==0)? clrRed : clrRoyalBlue);
         m_table.CellColor(c,r,(r%2==0)? clrWhiteSmoke : clrWhite);
        }
     }
//---     
   m_table.UpdateTable();
//---       
   CWndContainer::AddToElementsArray(0,m_table);
   return(true);
  }
  
//+------------------------------------------------------------------+
//|       Symbol                                             |
//+------------------------------------------------------------------+
bool CProgram::ModifyTable(int id)
  {
   int r=1;
   switch(id){
      case  0:         
         for(int c=0;c<COLUMNS2_TOTAL;c++)
         for(r=1;r<ROWS2_TOTAL;r++)
            m_table.SetValue(c,r,"rb1 "+(string)c+" "+(string)r);                                  
      break;
      
      case 1:
         for(int c=0;c<COLUMNS2_TOTAL;c++)
         for(r=1;r<ROWS2_TOTAL-5;r++)
            m_table.SetValue(c,r,"rb2 "+(string)c+" "+(string)r);  
      break;
      case 3:
         for(int c=0;c<COLUMNS2_TOTAL;c++)
         for(r=1;r<ROWS2_TOTAL-10;r++)
            m_table.SetValue(c,r,"rb3 "+(string)c+" "+(string)r);                                      
      break;
   }
      for(int c=0;c<COLUMNS2_TOTAL;c++)
      for(int rr=r;rr<ROWS2_TOTAL;rr++) m_table.SetValue(c,rr,"");

//---     
   m_table.UpdateTable();
//---       
   CWndContainer::AddToElementsArray(0,m_table);
   return(true);
  }  
